/*  $Id: stddynfun.c,v 2.2 2006/08/09 00:51:50 pary Exp $ */
/* Copyright (c) 1999-2004  Pavel Rychly        */

#include <string.h>
#include <ctype.h>
#include <locale.h>

const char * getnchar (const char* x, int n)
{
    static char ch[2] = " ";
    if ((int)strlen (x) < n)
	ch[0] = '\0';
    else
	ch[0] = x[n-1];
    return ch;
}

const char * getnextchar (const char* x, const char attr)
{
    static char ch[3] = "  ";
    ch[0] = '\0';
    while (*x) {
	if (*x++ == attr) {
	    ch[0] = attr;
	    ch[1] = *x;
	    break;
	}
    }
    return ch;
}

const char * getnextchars (const char* x, const char attr, int len)
{
    static char ch[11] = " ";
    char *s;
    if (len > 10)
	len = 10;
    while (*x) {
	if (*x++ == attr) {
	    ch[0] = *x;
	    break;
	}
    }
    for (s=ch; *x && len; len--)
	*s++ = *x++;
    *s = 0;
    return ch;
}

const char * getfirstn (const char* x, int len)
{
    static char result[128];
    strncpy (result, x, len);
    result[len] = '\0';
    return result;
}

const char * striplastn (const char* x, int cnt)
{
    static char result[128];
    size_t len = strlen (x);
    if (len > cnt) {
	size_t mlen = (len-cnt >= sizeof(result)) ? sizeof(result) -1 : len-cnt;
	strncpy (result, x, mlen);
	result[mlen] = '\0';
    } else {
	result[0] = '\0';
    }
    return result;
}

const char * lowercase (const char* x, const char *locale)
{
    static char result[128];
    char *r;
    const char *prev_locale = setlocale (LC_CTYPE, locale);
    for (r=result; *x && r-result < (int)(sizeof (result))-1; x++, r++)
	*r = tolower (*x);
    setlocale (LC_CTYPE, prev_locale);
    *r = '\0';
    return result;
}
